﻿''
'' ConsoleVB
''
'' Copyright (c) 2016 http://www.curict.com
'' This software is released under the MIT License, see LICENSE.txt.
''
Imports System.Data.SqlClient
Imports ConsoleVB.Extensions

Module Module1

    Sub Main()
        ' 接続文字列。環境に合わせて修正してください
        Dim connectionString As String = "SERVER=LOCALHOST\SQLEXPRESS;UID=sa2;PWD=sa2;DATABASE=Web"

        ' 通常パターン
        Normal(connectionString)

        ' 拡張メソッド(エクステンション)を使用してシンプルに
        UseExtension(connectionString)

        Console.ReadLine()
    End Sub

    ''' <summary>
    ''' 通常パターン
    ''' </summary>
    Private Sub Normal(ByVal connectionString As String)
        Using connection As New SqlConnection(connectionString)
            ' コネクションを開く
            connection.Open()

            ' コマンド作成
            Dim command As SqlCommand = connection.CreateCommand

            ' SQL
            command.CommandText = "SELECT COUNT(*) FROM sys.objects WHERE type IN (@type1, @type2, @type3)"

            ' SQLパラメータ設定
            Dim param1 As New SqlParameter("@type1", SqlDbType.VarChar)
            param1.Value = "S"
            command.Parameters.Add(param1)

            Dim param2 As New SqlParameter("@type2", SqlDbType.VarChar)
            param2.Value = "U"
            command.Parameters.Add(param2)

            Dim param3 As New SqlParameter("@type3", SqlDbType.VarChar)
            param3.Value = "PK"
            command.Parameters.Add(param3)

            ' コマンド実行
            Dim result As Object = command.ExecuteScalar()

            ' 結果表示
            Console.WriteLine(result.ToString)
        End Using

    End Sub

    ''' <summary>
    ''' 拡張メソッド(エクステンション)を使用
    ''' </summary>
    Private Sub UseExtension(ByVal connectionString As String)
        Using connection As New SqlConnection(connectionString)
            ' コネクションを開く
            connection.Open()

            ' コマンド作成
            Dim command As SqlCommand = connection.CreateCommand

            ' SQL
            command.CommandText = "SELECT COUNT(*) FROM sys.objects WHERE type IN (@type1, @type2, @type3)"

            ' SQLパラメータ設定
            Dim sqlParameters As List(Of SqlParameter) = New List(Of SqlParameter)()
            sqlParameters.AddSqlParameter(New SqlParameter("@type1", SqlDbType.VarChar)).Value = "S"
            sqlParameters.AddSqlParameter(New SqlParameter("@type2", SqlDbType.VarChar)).Value = "U"
            sqlParameters.AddSqlParameter(New SqlParameter("@type3", SqlDbType.VarChar)).Value = "PK"
            command.Parameters.AddParams(sqlParameters)

            ' コマンド実行
            Dim result As Object = command.ExecuteScalar()

            ' 結果表示
            Console.WriteLine(result.ToString)
        End Using
    End Sub

End Module
