﻿''
'' ConsoleVB
''
'' Copyright (c) 2016 http://www.curict.com
'' This software is released under the MIT License, see LICENSE.txt.
''

Imports System.Data.SqlClient
Imports System.Runtime.CompilerServices

Namespace Extensions
    Public Module SqlParameterExtension
        ''' <summary>
        ''' ListにSqlParameterを追加し、追加したSqlParameterを返す
        ''' 使用例
        ''' Dim sqlParameters As List(Of SqlParameter) = New List(Of SqlParameter)()
        ''' sqlParameters.AddSqlParameter(New SqlParameter("@type1", SqlDbType.VarChar)).Value = "S"
        ''' </summary>
        <Extension()> _
        Public Function AddSqlParameter(ByVal list As List(Of SqlParameter), ByVal parameter As SqlParameter) As SqlParameter
            list.Add(parameter)
            Return parameter
        End Function

        ''' <summary>
        ''' SqlParameterCollectionにList(Of SqlParameter)を追加
        ''' </summary>
        <Extension()> _
        Public Sub AddParams(ByVal collection As SqlParameterCollection, ByVal list As List(Of SqlParameter))
            For Each parameter As SqlParameter In list
                collection.Add(parameter)
            Next
        End Sub
    End Module
End Namespace
